# AI

Zed smoothly integrates LLMs in multiple ways across the editor.
Learn how to get started with AI on Zed and all its capabilities.

## Setting up AI in Zed

- [Configuration](./configuration.md): Learn how to set up different language model providers like Anthropic, OpenAI, Ollama, Google AI, and more.

- [Models](./models.md): Learn about the various language models available in Zed.

- [Subscription](./subscription.md): Learn about Zed's subscriptions and other billing-related information.

- [Privacy and Security](./privacy-and-security.md): Understand how Zed handles privacy and security with AI features.

## Agentic Editing

- [Agent Panel](./agent-panel.md): Create and manage interactions with language models.

- [Rules](./rules.md): How to define rules for AI interactions.

- [Tools](./tools.md): Explore the tools that enable agentic capabilities.

- [Model Context Protocol](./mcp.md): Learn about how to install and configure MCP servers.

- [Inline Assistant](./inline-assistant.md): Discover how to use the agent to power inline transformations directly within a file or terminal.

## Edit Prediction

- [Edit Prediction](./edit-prediction.md): Learn about Zed's AI prediction feature that helps autocomplete your code.

## Text Threads

- [Text Threads](./text-threads.md): Learn about an alternative, text-based interface for interacting with language models.
